Liferay.Loader.define("frontend-taglib-clay@6.3.16/NavigationBar", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/link', '@frontend-taglib-clay$clayui/navigation-bar', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = NavigationBar;

    var _button = _interopRequireDefault(require("@frontend-taglib-clay$clayui/button"));

    var _link = _interopRequireDefault(require("@frontend-taglib-clay$clayui/link"));

    var _navigationBar = _interopRequireDefault(require("@frontend-taglib-clay$clayui/navigation-bar"));

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function NavigationBar(_ref) {
      var _navigationItems$find;

      var cssClass = _ref.cssClass,
          inverted = _ref.inverted,
          navigationItems = _ref.navigationItems;
      return (/*#__PURE__*/_react.default.createElement(_navigationBar.default, {
          className: cssClass,
          inverted: inverted,
          triggerLabel: (_navigationItems$find = navigationItems.find(function (_ref2) {
            var active = _ref2.active;
            return active;
          })) === null || _navigationItems$find === void 0 ? void 0 : _navigationItems$find.label
        }, navigationItems.map(function (_ref3, index) {
          var active = _ref3.active,
              href = _ref3.href,
              label = _ref3.label;
          return (/*#__PURE__*/_react.default.createElement(_navigationBar.default.Item, {
              active: active,
              "data-nav-item-index": index,
              key: label
            }, href ? /*#__PURE__*/_react.default.createElement(_link.default, {
              className: "nav-link",
              displayType: "unstyled",
              href: href
            }, label) : /*#__PURE__*/_react.default.createElement(_button.default, {
              className: "nav-link",
              displayType: "unstyled"
            }, label))
          );
        }))
      );
    }
    //# sourceMappingURL=NavigationBar.js.map
  }
});
//# sourceMappingURL=NavigationBar.js.map